#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd([HERE],16,2);

int deadline = 10;
int score = 0;
int twistGoal;
bool lost;
bool clearedLost;

void setup()
{
  lcd.init();
  lcd.clear();
  lcd.backlight();
  const int analogInPin = 2;
  Serial.begin(9600);
  twistGoal = randomTwist(twist());
}

void loop()
{
  if (!lost)
  {
    printGame();
  }
  else
  {
    printLoss();
  }
}

int twist()
{
  int sensorValue = analogRead(A0);
  int twistPercentage = map(sensorValue, 0, 1023, 0, 100);
  return twistPercentage;
}

int randomTwist(int range)
{
  int randomNumber = random(0, range);
  return randomNumber;
}

int secondsFromStart()
{
  int seconds = round((millis() / 1000) * 10) / 10;
  return seconds;
}

void deadlineCheck()
{
  if (secondsFromStart() >= deadline)
  {
    deadline = deadline + 10;
    if (twist() == twistGoal)
    {
      scoreUp();
      twistGoal = randomTwist(100);
    }
    else
    {
      lost = true;
    }
  }
}

void scoreUp()
{
  score++;
}

int countdown()
{
  int number = deadline - secondsFromStart();
  return number;
}

void printGame()
{
  lcd.clear();
  lcd.setCursor(0,1);
  lcd.print(twist());
  lcd.setCursor(0,0);
  lcd.print(twistGoal);
  lcd.setCursor(5,0);
  lcd.print(countdown());
  deadlineCheck();
  lcd.setCursor(9,1);
  lcd.print("score");
  lcd.setCursor(5,1);
  lcd.print(score);
}

void printLoss()
{
  if(!clearedLost)
  {
    lcd.clear();
    clearedLost = true;
  }
  lcd.setCursor(5,0);
  lcd.print("score");
  lcd.setCursor(7,1);
  lcd.print(score);
}